#define YES 0x01
#define NO  0x00
#define     BLACK   0x00
#define     BLUE    0x01
#define     GREEN   0x02
#define     CYAN    0x03
#define     RED     0x04
#define     MAGENTA 0x05
#define     BROWN   0x06
#define     LIGHTGRAY 0x07
#define     DARKGRAY  0x08
#define     LIGHTBLUE 0x09
#define     LIGHTGREEN 0x0A
#define     LIGHTCYAN 0x0B
#define     LIGHTRED 0x0C
#define     LIGHTMAGENTA 0x0D
#define     YELLOW 0x0E
#define     WHITE 0x0F
#define     BLINK 0x80

char FILLER=' ',
     ATTR=0x07,
     SHADOW=YES,
     EXPLODE=YES;

unsigned char far *vid_mem=(unsigned char far *)0xb8000000,
              far *V;

char set_attr (char col, char bk) {
 char ATTR=0x00;
 ATTR|=col;
 ATTR|=(bk<<4);
 return (ATTR);
}

void write_char (char x, char y, char ch) {
 V=vid_mem;
 V += ((x*80 + y)<<1);
 *V++ = ch; /*  ᨬ */
 *V = ATTR; /*  ਡ */
}

void write_string (char x, char y, char *str) {
 char i;
 for (i=0;  *(str+i); i++) write_char (x, y+i, *(str+i));
}

char strlen (char *str) {
 char i;
 for (i=0x00; *(str+i);) i++;
 return (i);
}

void center_string  (char x, char y1, char y2, char *str) {
 char i,y;
 y=(y1+y2-strlen(str))>>1;
 for (i=0;  *(str+i); i++) write_char ( x, y+i, *(str+i));
 return;
}  

char read_char (char x, char y, char *attr) {
 char ch;
 V=vid_mem;
 V += ((x*80 + y)<<1);
 ch = *V++;  /* ᨬ */
 *attr = *V; /* ਡ */
 return (ch);
}

void change_attr (char x1, char y1, char x2, char y2, char attr) {
 char i,j;
 V=vid_mem; x2++; y2++;
 for (i=x1; i<x2; i++)
 for (j=y1; j<y2; j++) {
  V = vid_mem + ((i*80 + j)<<1) + 1;
  *V = attr; //  ਡ
 }
}

void save (char x1,char y1,char x2,char y2) {
 char i,j,ch,attr;
 x2++; y2++;
 for (i=x1; i<x2; i++) 
 for (j=y1; j<y2; j++) {
  ch=read_char (i,j,&attr);
  ATTR=attr;
  vid_mem+=4000;
  write_char (i,j,ch);
  vid_mem-=4000;
 } return;
}

void restore (char x1,char y1,char x2,char y2) {
 char i,j,ch,attr;
 x2++; y2++;
 for (i=x1; i<x2; i++) 
 for (j=y1; j<y2; j++) {
  vid_mem+=4000;
  ch=read_char (i,j,&attr);
  vid_mem-=4000;
  ATTR=attr;
  write_char (i,j,ch);
 } return;
}

char kbscan(void) {
 char sim;
 asm MOV  AH,0x00;     //뢠 ᨬ   
 asm INT  16H;
 asm MOV sim,AH; // AH=Scan-code, AL=ASCII code
 return (sim);
}

void kbclear(void) {
asm push es;
asm  cli;
asm  sub ax,ax;
asm  mov es,ax;
asm  mov al,es:[41ah];
asm  mov es:[41ch],al;
asm  sti;
asm pop es;
}

void clear (char x1,char y1,char x2,char y2) {
 char i,j;
 x2++; y2++;
 for (i=x1; i<x2; i++) 
 for (j=y1; j<y2; j++) write_char (i,j,FILLER);
 return;
}

void box (char x1, char y1, char x2, char y2, char sort) {
// ᮢ ࠬ:
//  012 Ŀ ͻ ķ ͸ ķ   
//  3 4 1 2 3 4 5 6 7
//  567  ͼ ͼ ; Ľ  
 unsigned char border[8][8]={
  {' ',' ',' ',' ',' ',' ',' ',' '},
  {'','','','','','','',''},
  {'','','','','','','',''},
  {'','','','','','','',''},
  {'','','','','','','',''},
  {'','','','','','','',''},
  {'','','','','','','',''},
  {'','','','','','','',''}
 };
 char i;
 if (!sort) for (i=0; i<8; i++) border[0][i]=FILLER; //  -ࠧ⥫
 for(i=x1+1; i<x2; i++) { // 
  write_char (i,y1,border[sort][3]);
  write_char (i,y2,border[sort][4]);
 }
 for (i=y1+1; i<y2; i++) { // ࠢ
  write_char (x1,i,border[sort][1]);
  write_char (x2,i,border[sort][6]);
 }
 write_char( x1, y1, border[sort][0]);
 write_char( x1, y2, border[sort][2]);
 write_char( x2, y1, border[sort][5]);
 write_char( x2, y2, border[sort][7]);
 return;
}

void window (char x1,char y1,char x2,char y2) {
 char j,cx1,cy1,cx2,cy2;
 if (EXPLODE) {
  cy1=(y2-y1)>>1;
  cy2=cy1+1;
  cx1=(x2-x1)>>1;
  cx2=cx1+1; 
  j=0x0f;
  do {
   box (cx1,cy1,cx2,cy2,0x02);
   FILLER=' ';
   box (cx1,cy1,cx2,cy2,0x00);
   if (cx1>x1) cx1--;
   else j&=0x0e;
   if (cx2<x2) cx2++;
   else j&=0x0d;
   if (cy1>y1) cy1--;
   else j&=0x0b;
   if (cy2<y2) cy2++;
   else j&=0x07;
  } while (j);
 }
 else { // normal
  FILLER=' ';
  clear (x1,y1,x2,y2); 
 }
 box (x1,y1,x2,y2,0x02);
 if (SHADOW) {
  j=y2+2;
  if (j<80) change_attr (x1+1, y2+1, x2, y2+2, 0x08); //Ver
  j=x2+1;
  if (j<25) change_attr (x2+1,y1+2,x2+1,y2+2, 0x08); //Hor
 } return;
}

#define UPR_SIM 0xfe

void text (char x1, char y1, char x2, char y2, char *str) {
 char Cods[16]= {
  '0','B','G','C','R','M','Y','L', 
  'D','b','g','c','r','m','y','W'
 };
 char i,j,k,sim,is1,is2,cod1,cod2;
 int n=0;
 x2++; y2++;
 for (i=x1; i<x2; i++) {
  if (str[n]=='\0') break;
  for (j=y1; j<=y2; j++) {
AGAIN:
   sim=str[n++];
   if (sim==UPR_SIM) {
    cod1=str[n++];
    for (k=0,is1=17; k<16; k++) if (cod1==Cods[k]) { is1=k; break; }
    if (is1<17) {
     cod2=str[n++];
     for (k=0,is2=17; k<8; k++) if (cod2==Cods[k]) { is2=k; break; }
     if (is2==17) sim=cod2;
     else { ATTR=set_attr(is1,is2); goto AGAIN; }
    }
    else sim=cod1;
   }
   if (sim=='\r') goto AGAIN;
   if (sim=='\n') break;
   if (sim=='\0') return;
   write_char (i,j,sim);
  }
  j=0;
 }
}

#define _ESC 0x01
#define _SBAR 0x39
#define _ENTER 0x1C
#define _PAGE_UP 0x49
#define _UP 0x48
#define _DOWN 0x50
#define _PAGE_DO 0x51

char popup (char x1, char y1, char x2, char y2, char col, char bk,
 char kol, char **str) {
 char cursor=0x00,sim,rev,i;
 save (x1,y1,x2,y2);
 ATTR=set_attr (col,bk);
 rev=0x70;
 FILLER=' ';
 clear (x1,y1,x2,y2);
 box (x1,y1,x2,y2,0x02);
 for (i=0; i<kol; i++) write_string (x1+1+i, y1+1, str[i]);
 while (1) {
  change_attr (x1+1+cursor, y1+1, x1+1+cursor, y2-1, rev);
  sim=kbscan();
  change_attr (x1+1+cursor, y1+1, x1+1+cursor, y2-1, ATTR);
  switch (sim) {
   case _ENTER: goto OUT;
   case _UP: 
    if (cursor>0x00) cursor--;
    else cursor=kol-0x01;
   break;
   case _DOWN: 
    if (cursor<kol-0x01) cursor++;
    else cursor=0x00;
   break;
   case _PAGE_UP: cursor=0x00; break;
   case _PAGE_DO: cursor=kol-0x01; break;
   default: break;
  }
 }
OUT: 
 restore (x1,y1,x2,y2);
 return (cursor);
}

void strrev(char *s) {
 char c; char *t;
 for (t=s+strlen(s)-1; s<t; s++,t--) {
  c=*s; *s=*t; *t=c;
 }
}   

void utoa (unsigned n, char *str,char field) {
 char *t=str,byte;
 for (byte=0x00; byte<field; byte++) *(str+byte)=' ';
 do {
  *str++=n%10+'0';
 } while ((n/=10)!=0);
 byte=*str; *str='\0';
 strrev (t);
 *str=byte;
 return;
}

char textmode (void) {
 // ⠭ ० 3, 80*25, 16 梥⮢
 // 頥 0  砥 訡
 asm mov ax,0003h;
 asm int 10h;
 asm mov ah,00fh;
 asm int 10h;
 asm cmp al,003h;
 asm jnz ModeError;
 asm mov al,1;
 asm jmp Exit;
ModeError:
 asm mov al,0;
Exit:
 return (_AL);
}

void goto_xy(char xpos,char ypos) {
 asm  mov	ah,0x02 ;
 asm mov	dl,ypos ; //⮫
 asm mov	dh,xpos	; //ப
 asm mov	bh,0x00 ;
 asm int	10h;
}

//////////////// ᭮  ணࠬ
#define SCREENS 9

void main (void) {
 char *screen[SCREENS]={
  "yB\n"
"ķ\n"
"  gB             yB               cBĿyB \n"
"  gB              yB               cB ͻ yB \n"
"  gB                  yB               cB          yB \n"
"                                                       cB c>  \\/     yB \n"
"  cBķyB             gB   yB           cB ͼ yB \n"
"  cB ᨡ yB             gB     yB           cByB \n"
"  cB   1 9 9 5   yB             gB      yB           cBĿyB \n"
"  cBͼyB                                      cByB \n"
"ķ \n"
"                               gBķyB    DOS  ᬮ        \n"
"    ᬠਢ            gBWBESCgByB  ⥪                          \n"
"    ᫥騥 :         gBͼyB                                  \n"
"                               gBķyB  ३  ᫥饩 ࠭    \n"
"    WB⨥ 娢樨     yB     gB WBgB yB   㭪                  \n"
"    WB䠩;       yB             gBͼyB                                  \n"
"    WBணࠬ-     yB            gBķyB  ३  ।饩 ࠭   \n"
"    WB-娢 ARJ.EXE  yB       gB WBgB yB   㭪                  \n"
"                               gBͼyB                                  \n"
"ͼ \n"
"ͼ\n"
"\0",
"yByB\n"
"      cB1. ⨥ 娢樨  ணࠬ-娢.yB\n"
"\n"
"      WB娢樥yB 뢠   祭 ᯥ樠 䠩-娢,  \n"
"   WBᦠ⮬ yB ᮤঠ ଠ,  ᠭ    ᪮쪮  -\n"
"   室 䠩.  娢 䠩 ⠢ 筮  gB20yB  gB90yB -\n"
"   業⮢ 㬬 ࠧ஢  室  䠩.  २⢠  娢樨  ।\n"
"    १ࢭ ஢ ,  -,   WByB  \n"
"   ⪮ ᪥  ᪥,   ࠭ 娢, -,  -\n"
"       娢 ࠧ WB㯯yB 䠩   ⠫, -\n"
"      ணࠬ த  ꥤ    ᮮ-\n"
"   ࠦ.\n"
"\n"
"      ⥩襩 娢樥  㦨,  ਬ,   䠩 ᫥-\n"
"   ⥫쭮⥩   ᨬ   \"ᨬ + ᫮ -\n"
"   ७\",  ⠪     ஡   ஢  -\n"
"   -६ ᨬ. ᭮,  WB譨 yB 娢 㤥 ᮢ襭  -\n"
"   宦  室 ⥪   ࠡ  ᫥ ਤ ᭠砫  \"-\n"
"   娢஢\".\n"
"\n"
"      ணࠬ, ।祭  WBᮧyB 娢   WB⠭yB  \n"
"    室 䠩,  뢠 WB娢஬yB.\0",
"yB\n"
"      ࠭ ⪨ 娢஢,   ப ᯮ  -\n"
"   쪮  .   ணࠬ gBARJyB, gBPKZIPyB, gBARCyB, gBRARyB, gBLHAyB   -\n"
"   .    娢    ᮧ  娢 䠩 ।\n"
"   WB७yB.  ᫨  娢 ᠭ ᪮쪮 䠩,   ࠢ, \n"
"   ᬮ  WByB - 祭  䠩.  窠 gBNorton Com-\n"
"   manderyB 뢠  娢,  ᮧ  祬  -\n"
"   묨  娢ࠬ.  ᫨     gBNCyB ⠭ ⨫ gBArcvi-\n"
"   ew.exeyB,   ᬮ  娢 筮 ⠭ 㪠⥫\n"
"   WB 娢 䠩yB    gBF3yB.\n"
"\n"
"      cB2. 娢 ARJ.yB\n"
"\n"
"      ணࠬ-娢 gBARJyB (ᯮ塞 䠩 gBarj.exeyB), , \n"
"   ୠ.   ⮨⢠ ⭮ WB᮪ ⥯ ᦠyB ଠ樨\n"
"    筮 ன ࠡ,   ⠪  ᮧ WB⮬\n"
"   娢yB, ᯮ ᫥⥫쭮  ᪮쪨 ᪥.\n"
"\n"
"      娢  ࠢ १ WB பyB ᪠, -\n"
"     ᫥騩 :\n"
"      gBarj  [०] _娢 [⠫\\][_䠩]yB\n"
"        祭 :\0",
"yB\n"
"      gByB -    WB㪢yB,    ணࠬ ARJ WB ⥫쭮yB.\n"
"   ਬ, gBayB 砥 \"WB 䠩  娢yB\";\n"
"\n"
"      gB०yB - 㪠뢠  ।騬 ᨬ gB-yB   ॡ㥬\n"
"    ணࠬ gBARJyB ⢨.  ਬ,  gB-jt1yB 砥 \"WB஢ ࠢ-\n"
"      娢yB\";\n"
"\n"
"      gB_娢yB - WByB ࠡ뢠 WB娢 䠩yB.  ᫨ ⠪ 䠩 \n"
"   ,   ⮬᪨ WBᮧyB. 㬮砭 । -\n"
"   ७ WBarjyB     㪠뢠;\n"
"\n"
"      gB⠫yB -    ⠫,   ஬ ᮤঠ WB娢㥬 䠩yB.\n"
"   ᫨ ⠫  㪠, ࠧ㬥 WB⥪騩yB;\n"
"      gB_䠩yB -    䠩,  砥  娢.    \n"
"    ᯮ짮 ᨬ gB*yB  gB?yB  ᫨   ,  ࠧ㬥\n"
"   WB 䠩yB  ⥪饣 ⠫.\n"
"\n"
"       ਢ ᢮   ० ணࠬ,  ࠧ  -\n"
"    믮塞  ⢨.  㪠뢠  WB㪢yB,  ०\n"
"   -  ।騬 ᨬ WB'-'yB.\0",
"yB\n"
"      cB饭 䠩  娢:yB\n"
"      gBayB (add) - WByB  娢  㪠   䠩;\n"
"\n"
"      gBuyB (update) - WByB 娢,     㪠  -\n"
"     䠩 ⮫쪮 ,    WByB  娢,     \n"
"    WB࠭ yB, 祬  㪠 䠩;\n"
"\n"
"      gBmyB (move) - WB६頥yB  娢,   室 䠩 WB㤠yB ᫥\n"
"     娢;\n"
"\n"
"      gB-ryB -   娢 WBॢ ⠫yB 娢㥬 ⠫;\n"
"\n"
"      gB-gyB - WB  ஫yB;  gByB -  ப; ᫥  \n"
"   ஫  娢  祭      ⮫쪮\n"
"   WB 㪠 ⮣   ஫yB;\n"
"\n"
"      gB-jeyB - ᤥ 娢 WBᠬࠧ稢騬yB;  䠩  ७\n"
"   gBarjyB  ᮧ WBᯮ塞 䠩yB  ७ gBexeyB,   ᪥ ண\n"
"   㤥 뢥  gBContinue extraction?yB (த 祭?)  \n"
"   ⢥ gBYyB 娢 㤥 ࠧ.\0",
"yB\n"
"      cB祭 䠩  娢:yB\n"
"\n"
"      gBeyB (extract) - WByB 䠩  娢;\n"
"      gBxyB - WByB, ࠭ WBॢ ⠫yB, ᠭ  娢;\n"
"\n"
"      gBdyB (delete) - WB㤠yB  䠩  娢 ᫥  祭;\n"
"      gB-jryB -  㪠 ⮣  gBARJyB ⠥ WB⠭yB  娢\n"
"   WB० 䠩yB, ᫨   ०  ࠭;  gB-jr1yB\n"
"   뢠    ⠭;\n"
"\n"
"      cBᬮ  ஢ઠ 娢:yB\n"
"\n"
"      gBlyB (list) - 뢥 WB 娢yB  ࠭;\n"
"\n"
"      gBpyB (print) - 뢥 WBᮤন 䠩yB 娢  ࠭;   -\n"
"   짮  ० ⮫쪮  ⥪⮢ 䠩;\n"
"\n"
"      gBtyB (test) - ஢ WB࠭ 䠩yB  娢;   訡-\n"
"     뢥 ᮮ饭.    ० ᥣ    ஢ન\n"
"   娢  WB  ᪥yB,    ᯮ  ७ ⭮\n"
"   .\0",
"yB\n"
"      cB⥫ :yB\n"
"\n"
"      gBiyB (include)  -  WBꥤyB 娢 (ந室 ᮥ  1- \n"
"   㪠   ப 娢);\n"
"      gBnyB (name)  WB२yB  䠩   娢 (   뢮\n"
"   );\n"
"\n"
"      cB롮 ⮤ ᦠ:yB\n"
"\n"
"      娢  ᮧ 娢  ࠧ筮 WB⥯ ᦠyB ଠ-\n"
"   樨,    WB᪮yB  WByB  娢  WB祭yB   -\n"
"   .  롮 ⮤ ᦠ 㦠 ᫥騥 WByB:\n"
"\n"
"      gB-m0yB - ࠭ 䠩  ᦠ;\n"
"      gB-m1yB - ଠ쭮 ᦠ⨥ (WB롨ࠥ  㬮砭yB);\n"
"      gB-m2yB - ᪮७ ⭮ ᦠ⨥;\n"
"      gB-m3yB - ஥   ⭮ ᦠ⨥;\n"
"      gB-m4yB - ३襥   ⭮ ᦠ⨥.\n"
"\n"
"      cB⢥   娢:yB\0",
"yB\n"
"         ,  ਬ,  ᮧ  ४ਨ, -\n"
"      娢 㦥 饣 䠩,  ARJ 뢠 ࠡ    뢮\n"
"    ᮮ⢥騩 WByB.  ⢥ ᫥    WB㪢 -\n"
"    yB  gBEnteryB. ਠ ⢥⮢ ᫥騥:\n"
"\n"
"       gByyB (Yes) - ⢥ \"\"  ⥪騩 ;\n"
"       gBnyB (No) - ⢥ \"\"  ⥪騩 ;\n"
"       gBqyB (Quit) -   娢;\n"
"       gBayB (Always) - ᥣ ⢥ \"\"   ;\n"
"       gBsyB (Skip) - ᥣ ⢥ \"\"   ;\n"
"        ⮬᪮ ⢥ \"gByB\"     ᪥ 娢\n"
"     짮 箬 gB-yyB.\n"
"\n"
"       cB⮬ 娢.yB\n"
"\n"
"       筮 ᯮ  WB७yB  ꥬ ଠ樨 WB ᪥-\n"
"    yB.   ⮬ gBARJyB ᮧ WB᫥⥫쭮 娢yB  ७ﬨ gBarjyB,\n"
"    gBa01yB, gBa02yB  ..\n"
"       WByB ⮬ 娢樨 㪠뢠 箬 gB-vxxxKyB,  gBxxxyB - WBࠧ-\n"
"    yB  ⮬,  㪠  WB  yB.    ᪥ gB1.44yB   \n"
"    gB1450KyB,   ᪥ gB1.2yB  - gB1210KyB.   gB-vwyB ।뢠  ࠭  \0",
"yB\n"
"     ⮬ ⮫쪮 gB楫 䠩yB,    室 䠩   ࠧ-\n"
"     ࠧ묨 ⮬.   gB-vayB 뢠  室  \n"
"   ⮬ ⮬ WB஢  稥 yB  .  ᫨  -\n"
"    ᪥ 筮 , 楫ᮮࠧ ᮧ WB yB ⮬ -\n"
"   娢,  ⥬ WB९yB ⤥ ⮬ WB ᪥yB.   ⮬  -\n"
"    gB-jyvyB, 㡨騩 WByB । ᮧ । ⮬.\n"
"      WByB ⮬ 娢  ᬠਢ   WB娢yB.  \n"
"   ᬮ ᥣ  ⮬ 娢 ᯮ  gB-vyB.\n"
"\n"
"      cB3. ਬ  娢 ARJ.yB\n"
"       ਢ  ᪮쪮  ਬ஢  ࠡ   娢,  騬 \n"
"   gBmy1.arjyB:\n"
"      gBARJ a my1yB                    娢 䠩 ⥪饣 ⠫;\n"
"      gBARJ a my1 text1 text2yB        娢 䠩 text1  text2;\n"
"      gBARJ e my1yB                   䠩  娢;\n"
"      gBARJ x my1yB                  , ࠭ ॢ ⠫;\n"
"      gBARJ a -v -jyv my1 *.txtyB     䠩  ७  txt  \n"
"   ⮬ 娢;\n"
"      gBARJ x -v my1yB                䠩  ⮬ 娢;\n"
"      gBARJ a  -r  -je  my1yB         ॢ ⠫  ᠬࠧ-\n"
"   稢騬 娢.\n"
"      GB[ ⥪]yB\0"
 };
 char *mm0[2]={"  ணࠬ","  DOS"};
 char scr,k,c,*numpage="__";

 if (!textmode()) 
  return;
 
 goto_xy(0x19,0x00);
AGAIN:
 kbclear();
 for (scr=0;;) {
AGAIN_2:
  EXPLODE=YES; SHADOW=NO;
  ATTR=set_attr (YELLOW,BLUE);
  window (0,0,24,79);
  text (1,1,23,78,screen[scr]);
  if (scr) {
   ATTR=set_attr (WHITE,BLUE);
   utoa (scr,numpage,2);
   center_string (24,1,78,numpage);
  }
READKEY:
  c=kbscan();
  switch (c) {
   case _DOWN: if (scr<SCREENS-1) scr++; else goto READKEY; break;
   case _UP:   if (scr>0) scr--; else goto READKEY; break;
   case _ESC:
    k=popup (6, 28, 9, 52, YELLOW,GREEN, 2, mm0);
    if (k) goto OUT_MAIN;
   break;
   default: goto READKEY;
  }
  continue; // 頥  ப⪥ ࠭
 }
OUT_MAIN: 
 ATTR=0x07; clear (0,0,24,79);
 goto_xy(0x00,0x00);
 return;
}
asm db 10,13,'Nick Soft',10,13,'$'