/*
//Test:
typedef unsigned screen_array[25][80];
screen_array far *screen_ptr = (screen_array far *)0xB8000000L;
#define screen (*screen_ptr)
void main (void) { screen[0][0]=0x0733; }
*/
#define YES 0x01
#define NO  0x00
#define     BLACK   0x00
#define     BLUE    0x01
#define     GREEN   0x02
#define     CYAN    0x03
#define     RED     0x04
#define     MAGENTA 0x05
#define     BROWN   0x06
#define     LIGHTGRAY 0x07
#define     DARKGRAY  0x08
#define     LIGHTBLUE 0x09
#define     LIGHTGREEN 0x0A
#define     LIGHTCYAN 0x0B
#define     LIGHTRED 0x0C
#define     LIGHTMAGENTA 0x0D
#define     YELLOW 0x0E
#define     WHITE 0x0F
#define     BLINK 0x80

char FILLER=' ',
     ATTR=0x07,
     SHADOW=YES,
     EXPLODE=YES,
     TIMEOUT=NO;

unsigned char far *vid_mem=(unsigned char far *)0xb8000000,
              far *V;

char set_attr (char col, char bk) {
 char ATTR=0x00;
 ATTR|=col;
 ATTR|=(bk<<4);
 return (ATTR);
}

void write_char (char x, char y, char ch) {
 V=vid_mem;
 V += ((x*80 + y)<<1);
 *V++ = ch; /*  ᨬ */
 *V = ATTR; /*  ਡ */
}

void write_string (char x, char y, char *str) {
 char i;
 for (i=0;  *(str+i); i++) write_char (x, y+i, *(str+i));
}

char strlen (char *str) {
 char i;
 for (i=0x00; *(str+i);) i++;
 return (i);
}

void center_string  (char x, char y1, char y2, char *str) {
 char i,y;
 y=(y1+y2-strlen(str))>>1;
 for (i=0;  *(str+i); i++) write_char ( x, y+i, *(str+i));
 return;
}

char read_char (char x, char y, char *attr) {
 char ch;
 V=vid_mem;
 V += ((x*80 + y)<<1);
 ch = *V++;  /* ᨬ */
 *attr = *V; /* ਡ */
 return (ch);
}

/* #define between(a,x,b) (((x>=a)&&(x<=b))?YES:NO)

char move_char (char x1, char y1, char x2, char y2) {
 char s,a,is1=NO,is2=NO;
 if (between (0x00,x1,0x18) && between (0x00,y1,0x4f)) is1=YES;
 if (between (0x00,x2,0x18) && between (0x00,y2,0x4f)) is2=YES;
 V = vid_mem + ((x1*80 + y1)<<1);
 s=*V;
 if (is1) *V++ = FILLER;   //  ᨬ 
 a=*V;
 if (is1) *V =   ATTR;  //  ਡ 
 V = vid_mem + ((x2*80 + y2)<<1);
 if (is2) { *V++=s; *V=a; return 0x01; }
 return 0x00;
} */

void change_attr (char x1, char y1, char x2, char y2, char attr) {
 char i,j;
 V=vid_mem; x2++; y2++;
 for (i=x1; i<x2; i++)
 for (j=y1; j<y2; j++) {
  V = vid_mem + ((i*80 + j)<<1) + 1;
  *V = attr; //  ਡ
 }
}

void save (char x1,char y1,char x2,char y2) {
 char i,j,ch,attr;
 x2++; y2++;
 for (i=x1; i<x2; i++) 
 for (j=y1; j<y2; j++) {
  ch=read_char (i,j,&attr);
  ATTR=attr;
  vid_mem+=4000;
  write_char (i,j,ch);
  vid_mem-=4000;
 } return;
}

void restore (char x1,char y1,char x2,char y2) {
 char i,j,ch,attr;
 x2++; y2++;
 for (i=x1; i<x2; i++) 
 for (j=y1; j<y2; j++) {
  vid_mem+=4000;
  ch=read_char (i,j,&attr);
  vid_mem-=4000;
  ATTR=attr;
  write_char (i,j,ch);
 } return;
}

char kbscan(void) {
 char sim;
 asm MOV  AH,0x00;     //뢠 ᨬ   
 asm INT  16H;
 asm MOV sim,AH; // AH=Scan-code, AL=ASCII code
 return (sim);
}

void kbclear(void) {
asm push es;
asm  cli;
asm  sub ax,ax;
asm  mov es,ax;
asm  mov al,es:[41ah];
asm  mov es:[41ch],al;
asm  sti;
asm pop es;
}

char kbhit(void) {
 asm push es;
 asm  mov ax,0;
 asm  mov es,ax;
 asm  mov al,es:[41ah];
 asm  mov ah,es:[41ch];
 asm pop es;
 asm cmp ah,al;
 asm jne KEYPRESSED;
 return 0x00;
KEYPRESSED:
 return 0x01;
}

void clear (char x1,char y1,char x2,char y2) {
 char i,j;
 x2++; y2++;
 for (i=x1; i<x2; i++) 
 for (j=y1; j<y2; j++) write_char (i,j,FILLER);
 return;
}

void box (char x1, char y1, char x2, char y2, char sort) {
// ᮢ ࠬ:
//  012 Ŀ ͻ ķ ͸ ķ   
//  3 4 1 2 3 4 5 6 7
//  567  ͼ ͼ ; Ľ  
 unsigned char border[8][8]={
  {' ',' ',' ',' ',' ',' ',' ',' '},
  {'','','','','','','',''},
  {'','','','','','','',''},
  {'','','','','','','',''},
  {'','','','','','','',''},
  {'','','','','','','',''},
  {'','','','','','','',''},
  {'','','','','','','',''}
 };
 char i;
 if (!sort) for (i=0; i<8; i++) border[0][i]=FILLER; //  -ࠧ⥫
 for(i=x1+1; i<x2; i++) { // 
  write_char (i,y1,border[sort][3]);
  write_char (i,y2,border[sort][4]);
 }
 for (i=y1+1; i<y2; i++) { // ࠢ
  write_char (x1,i,border[sort][1]);
  write_char (x2,i,border[sort][6]);
 }
 write_char( x1, y1, border[sort][0]);
 write_char( x1, y2, border[sort][2]);
 write_char( x2, y1, border[sort][5]);
 write_char( x2, y2, border[sort][7]);
 return;
}

void window (char x1,char y1,char x2,char y2) {
 char j,cx1,cy1,cx2,cy2;
 if (EXPLODE) {
  cy1=(y2-y1)>>1;
  cy2=cy1+1;
  cx1=(x2-x1)>>1;
  cx2=cx1+1; 
  j=0x0f;
  do {
   box (cx1,cy1,cx2,cy2,0x02);
   FILLER=' ';
   box (cx1,cy1,cx2,cy2,0x00);
   if (cx1>x1) cx1--;
   else j&=0x0e;
   if (cx2<x2) cx2++;
   else j&=0x0d;
   if (cy1>y1) cy1--;
   else j&=0x0b;
   if (cy2<y2) cy2++;
   else j&=0x07;
  } while (j);
 }
 else { // normal
  FILLER=' ';
  clear (x1,y1,x2,y2); 
 }
 box (x1,y1,x2,y2,0x02);
 if (SHADOW) {
  j=y2+2;
  if (j<80) change_attr (x1+1, y2+1, x2, y2+2, 0x08); //Ver
  j=x2+1;
  if (j<25) change_attr (x2+1,y1+2,x2+1,y2+2, 0x08); //Hor
 } return;
}

#define UPR_SIM 0xfe

void text (char x1, char y1, char x2, char y2, char *str) {
 char Cods[16]= {
  '0','B','G','C','R','M','Y','L', 
  'D','b','g','c','r','m','y','W'
 };
 char i,j,k,sim,is1,is2,cod1,cod2;
 int n=0;
 x2++; y2++;
 for (i=x1; i<x2; i++) {
  if (str[n]=='\0') break;
  for (j=y1; j<=y2; j++) {
AGAIN:
   sim=str[n++];
   if (sim==UPR_SIM) {
    cod1=str[n++];
    for (k=0,is1=17; k<16; k++) if (cod1==Cods[k]) { is1=k; break; }
    if (is1<17) {
     cod2=str[n++];
     for (k=0,is2=17; k<8; k++) if (cod2==Cods[k]) { is2=k; break; }
     if (is2==17) sim=cod2;
     else { ATTR=set_attr(is1,is2); goto AGAIN; }
    }
    else sim=cod1;
   }
   if (sim=='\r') goto AGAIN;
   if (sim=='\n') break;
   if (sim=='\0') return;
   write_char (i,j,sim);
  }
  j=0;
 }
}

#define _ESC 0x01
#define _SBAR 0x39
#define _ENTER 0x1C
#define _PAGE_UP 0x49
#define _UP 0x48
#define _DOWN 0x50
#define _PAGE_DO 0x51

char popup (char x1, char y1, char x2, char y2, char col, char bk,
 char kol, char **str) {
 char cursor=0x00,sim,rev,i;
 save (x1,y1,x2,y2);
 ATTR=set_attr (col,bk);
 rev=0x70;
 FILLER=' ';
 clear (x1,y1,x2,y2);
 box (x1,y1,x2,y2,0x02);
 for (i=0; i<kol; i++) write_string (x1+1+i, y1+1, str[i]);
 while (1) {
  change_attr (x1+1+cursor, y1+1, x1+1+cursor, y2-1, rev);
  while (!kbhit()) {
   if (TIMEOUT) { TIMEOUT=NO; cursor=0xff; goto OUT; }
  }
  sim=kbscan();
  change_attr (x1+1+cursor, y1+1, x1+1+cursor, y2-1, ATTR);
  switch (sim) {
   case _ENTER: goto OUT;
   case _UP: 
    if (cursor>0x00) cursor--;
    else cursor=kol-0x01;
   break;
   case _DOWN: 
    if (cursor<kol-0x01) cursor++;
    else cursor=0x00;
   break;
   case _PAGE_UP: cursor=0x00; break;
   case _PAGE_DO: cursor=kol-0x01; break;
   default: break;
  }
 }
OUT: 
 restore (x1,y1,x2,y2);
 return (cursor);
}

/* #define CLEAR     0x00
#define TO_LEFT   0x01
#define TO_RIGHT  0x02
#define TO_UP     0x03
#define TO_DOWN   0x04

void movescreen (char Num) {
 char i,j,k,Rep;
 ATTR=0x07; FILLER=' ';
 // switch (Num) {
//  case TO_LEFT:
//  case TO_RIGHT: Rep=80; break;
//  case TO_UP:
//  case TO_DOWN: Rep=25; break;
//  default: Rep=1; break;
// }  
 //for (k=0; k<Rep; k++) {
  switch (Num) {
   case TO_UP:    
    for (i=0; i<25; i++) 
    for (j=0; j<80; j++) 
     move_char (i,j,i-1,j);
   break;
   case TO_DOWN:    
    for (i=0; i<25; i++) 
    for (j=0; j<80; j++) 
     move_char (i,j,i+1,j);
   break;
   case TO_LEFT:    
    for (j=0; j<80; j++) 
    for (i=0; i<25; i++) 
     move_char (i,j,i,j-1);
   break;
   case TO_RIGHT:    
    for (j=0; j<80; j++) 
    for (i=0; i<25; i++) 
     move_char (i,j,i,j+1);
   break;
   default : FILLER=' '; ATTR=0x07; clear (0,0,24,79); return;
  }
 //}
}     */

#include <dos.h>
void interrupt (* old_int1C)(...);
void (* Get_Draw)(void);
void interrupt ISR_int1C(...);
void Init_int1C(void); 
int Shut_int1c (void);
char Sec=NO,Min=NO,Hour=NO,Count=NO,TIMEDRAW=NO,CONTROLTIME=NO;

void Init_int1C(void) {
 old_int1C = getvect(0x1C);
 disable();
 setvect(0x1C, ISR_int1C);
 enable();
 return;
}

int Shut_int1C (void) {
 disable();
 if(getvect(0x1C) != ISR_int1C) { enable(); return 0; }
 setvect(0x1C, old_int1C);
 enable();
 return 1;
}

void interrupt ISR_int1C(...) {
 old_int1C();
 disable();
 outportb(0x20, 0x20);
 enable();
 Count++;
 if (Count==18) {
  Count=0; Sec++;
  if (TIMEDRAW) Get_Draw();
  if (Sec==60) {
   Sec=0; Min++;
   if (Min==60) { Hour++; Min=0; }
  }
 }
}

static char curtime;
unsigned char far *V_Addr;

void controltime (void) {
 curtime++;
 *V_Addr++ = ''; /*  ᨬ */
 *V_Addr++ = 0x07; /*  ਡ */
 if (curtime>=CONTROLTIME) {
  TIMEDRAW=NO;
  TIMEOUT=YES;
 }
}

void timewindow (char x, char y1, char y2, char *hdr) {
 char j;
 SHADOW=EXPLODE=NO;
 ATTR=set_attr(LIGHTGREEN,CYAN);
 window (x, y1, x+3, y2);
 center_string (x+1,y1,y2,hdr);
 ATTR=0x07;
 for (j=y1+1; j<y2; j++) write_char (x+2,j,'');
 curtime=NO; CONTROLTIME=y2-y1-1;
 V_Addr=vid_mem + (((x+2)*80 +y1+1)<<1);
 Get_Draw=controltime;
 TIMEDRAW=YES;
}

void strrev(char *s) {
 char c; char *t;
 for (t=s+strlen(s)-1; s<t; s++,t--) {
  c=*s; *s=*t; *t=c;
 }
}   

void utoa (unsigned n, char *str,char field) {
 char *t=str,byte;
 for (byte=0x00; byte<field; byte++) *(str+byte)=' ';
 do {
  *str++=n%10+'0';
 } while ((n/=10)!=0);
 byte=*str; *str='\0';
 strrev (t);
 *str=byte;
 return;
}

int chrinstr (char c,char *str) {
 unsigned k;
 for (k=0; *(str+k); k++) if (*(str+k)==c) return (k);
 return (-1);
}

#define MAINDELAY 250
void beeps (char *notes) {
 unsigned octav[3][7]={ // , ࢠ,  ⠢
  {131,147,165,175,196,220,247},
  {262,294,330,349,392,440,494},
  {523,587,659,698,784,880,988}
 };
 unsigned diez[3][5]={ //    ⠢ (,,,᮫,)
  {139,156,185,208,233},
  {277,311,370,415,466},
  {554,622,740,830,932}
 };
 char *octav_str="asdfghj",       //祭   
      *diez_str="wetyu";          // ப ࠬ஢
 char oct=1,c,k;
 unsigned i,freq; int j;
 for (i=0; ; i++) {
  c=*(notes+i);
  if (c==0x00) { i=0; continue; } //!!!     
  if (c=='<') { if (oct) { oct--; continue; } }
  else if (c=='>') { if (oct<2) { oct++; continue; } }
  else if ((j=chrinstr (c,octav_str))!=-1) freq=octav[oct][j];
  else if ((j=chrinstr (c,diez_str))!=-1) freq=diez[oct][j];
  else freq=0;
  if (freq) {
   sound (freq);
   delay (MAINDELAY);
   nosound();
  }
  else delay (MAINDELAY);
  if (kbhit()) break;
 }
 kbclear(); delay (30);
 return;
}

char textmode (void) {
 // ⠭ ० 3, 80*25, 16 梥⮢
 // 頥 0  砥 訡
 asm mov ax,0003h;
 asm int 10h;
 asm mov ah,00fh;
 asm int 10h;
 asm cmp al,003h;
 asm jnz ModeError;
 asm mov al,1;
 asm jmp Exit;
ModeError:
 asm mov al,0;
Exit:
 return (_AL);
}

void goto_xy(char xpos,char ypos) {
 asm  mov	ah,0x02 ;
 asm mov	dl,ypos ; //⮫
 asm mov	dh,xpos	; //ப
 asm mov	bh,0x00 ;
 asm int	10h;
}

//////////////// ᭮  ணࠬ
#define SCREENS 13
#define QUESTIONS 14
#define MAXANSWERS 3

void estimation (unsigned bad, unsigned all) {
 unsigned ball;
 char *Est=
 "⢮ ᮢ: _     \n" // 4 str, 28 col
 " ⮪:     _     \n"
 " ⮪:    _     \n"
 "WB:              _     \0";
 char *melodies[4]={ // Santa Lucia 
  "<g-g-->aa<jj---f-f--hhgg---d-h--ggtf---f-d-s-h-g---"
  "g-g-->aa<jj---f-f--hhgg---d-h--ggtf---f-d-s-h-g--->"
  "d-s-a-<jh>s---s-a-<j-tg>a---daa<ggdf>ss---s-<h--j>s-a-"
  "d-s-a-<jh>s---s-a-<j-tg>a---daa<ggdf>ss---s-d--ss-a---\0",
                     // Grande Valse brillante, F.Chopin
  "<u->sef-<u->efg-<u->fgy-u--uu>a-<uy-y-uyg-g-ygf-f-gfe-"
  "<u->sef-<u->efg-<u->fgy-u--usuw-u>a<uy-<j->yuyg-<u->gygf-e-uuuu"
  "<u->sef-<u->efg-<u->fgy-u--uu>a-<uy-y-uyg-g-ygf-f-gfe-"
  "<u->sef-<u->efg-<u->fgy-u--usuw-u>a<uy-<j->yuyg-<u->gygf-e-eeee"
  "eeeeeefea<yedffffffey>aeydfffffffgfey>a-f-ew<g-u-yea-"
  "eeeeeefea<yedffffffey>aeydfffffffgfey>a-f-ew<g-y--a-\0",
                     // 檮 ஭, ..
  "<jhyh>a--sa<j>ad--fdedjhyhjhyh>a--<h>a<jhghjhghjhgtd---"
  "<jhyh>a--sa<j>ad--fdedjhyhjhyh>a--<h>a<jhghjhghjhgtd---"
  "dfgghgfds<g>dfgghgfds-asddfdsa<jd>asddfdsa<j-"
  "<jhyh>a--sa<j>ad--fdedjhyhjhyh>a--<hj>a<jhyhdfsa-<j-h-"
  ">dfgghgfds<g>dfgghgfds-asddfdsa<jd>asddfdsa<j-"
  "<jhyh>a--sa<j>ad--fdedjhyhjhyh>a--<hj>a<jhyhdfsa-<j-h-"
  ">hj>w-<hj>w<jhytyhjtdhj>w-<hj>w<jhytjydh--"
  "hj>w-<hj>w<jhytyhjtdhj>w-<hj>w<jhytjydh--\0",
                     // Fur Elise, L.V.Beethoven
  "deded<j>sa<h-adhj-dyj>a-<d>deded<j>sa<h-"
 "<adhj-d>a<jh>deded<j>sa<h-adhj-dyj>a-<d>"
 "-deded<j>sa<h-<adhj>a<jh-j>asd<g>fds<f>d"
 "sa<d>sa<j-d>d--d-->d--<edededed<j>sa<h-a"
 "dhj-dyj>a-<d>deded<j>sa<h-adhj>a<jh>\0"
 };
 if (bad<2) ball=5;
 else if (bad<all/4+2) ball=4;
 else if (bad<all/2) ball=3;
 else ball=2;
 utoa (QUESTIONS,&Est[21],5);
 utoa (all,&Est[21+28],5);
 utoa (bad,&Est[21+28*2],5);
 utoa (ball,&Est[21+28*3+3],5);
 kbclear();
 clear (0,0,24,79);
 ATTR=set_attr (LIGHTGRAY,BLACK);
 window (1,24,6,55);
 text (2,26,6,54,Est);
 beeps (melodies[ball-0x02]);
 return;
}

//screen[SCREENS],       // ࠭  ⥪⮬
//see[SCREENS];    // 뫨  ᬮ७ ࠭
//questions[QUESTIONS];  //  ᮢ
//maxlen,  //    ਧ⠫
//points[QUESTIONS],  // ᫮ ਠ⮢  ᠬ
//correct[QUESTIONS], //  ࠢ ਠ⮢
//goscreens[QUESTIONS]; // ࠭, 㤠 ᫥   砥 ࠢ. ⢥
//replies[QUESTIONS][MAXANSWERS]; // ਠ ⢥⮢

void main (void) {
 char *screen[SCREENS]={
"yB\n"
"ķ\n"
"  gB                               yB  \n"
"  gB                            yB  \n"
"  gB                           yB  \n"
" ķ  \n"
"     gB¿yB                       ķ     DOS  ᬮ      \n"
"     gByB                       WBESCyB    ३  ᠬ        \n"
"     ணࠬ ᮤন          ͼ                                 \n"
"     ଠ        ķ  ३  ᫥饩 ࠭   \n"
"      䠩 DOS         WByB    㭪                 \n"
"     让 ,     ͼ                                 \n"
"        ᢮   ķ  ३  ।饩 ࠭  \n"
"     ਠ.           gByB    WByB    㭪                 \n"
"                         gByB   ͼ                                 \n"
" ͼ \n"
"   \n"
" cB           \\\\|//         yB                              cByB      \n"
" cB           (o o)         yB    ,              cB   \\yB     \n"
" cB  ----oOOO--(_)--OOOo----yB       1996.                  cByB   \n"
"                                                        cB OO  O yB   \n"
"ͼ\n"
"\0",
"                          WB  䠩.yB\n"
"      cB1. । ⭮ 䠩.yB\n"
"         䠩   ᮡ ⥣ਥ ᯮ塞\n"
"   ணࠬ.   䠩   ७ WBBATyB ( ᪮ ᫮\n"
"   WBbatchyB  - \"\",\"㯯\").   ⭮ 䠩 ⢫ 筮\n"
"   ⠪ ,    筮 ᯮ塞 ணࠬ  ७ WBCOMyB \n"
"   WBEXEyB,        ⮣  㪠뢠    䠩  ,  ᫨ ॡ,\n"
"   ࠬ.\n"
"         䠩  ᮡ.    㦠   ࣠樨 㤮\n"
"   ⢨  짮⥫    ਪ묨  ணࠬ묨   ⥬.\n"
"     䠩,   ⫨稥   ᯮ塞 ணࠬ,  ᮤন \n"
"   設 ,   WB⥪yB,     ஬\n"
"   DOS. ப ⮣ ⥪  ।⠢ ᮡ:\n"
"      cB-yB 譨  ७ WB DOSyB;\n"
"      cB-yB WB饭yB    ᯮ塞  ணࠬ  ७ COM  EXE,  \n"
"   ⠪ 맮 㣨  䠩;\n"
"      cB-yB WBᯥ樠  yB   ࠢ 뤠祩  ࠭,   ⠪ \n"
"   ࣠樨 ⢫  横;\n"
"      cB-yB WB⪨yB,      ᮢ蠥 室  믮  \n"
"    䠩 ᫮.\n"
"         樨,   ᪫祭 ⮪,    \n"
"   WBDOSyB.   権   ᯮ짮 ⮫쪮    ⭮  䠩,\n"
"   㣠   ᯮ짮    ப DOS.\0",
"      cB2. ᯮ짮  䠩.yB\n"
"         ⥪⮢ ।    \n"
"      gBCOPY CON <_䠩>yB\n"
"      䠩  ७ WBBATyB  ᠢ    ப\n"
"      gBclsyB\n"
"      gBveryB\n"
"         䠩,    頥  ࠭    gBclsyB  \n"
"   ᮮ頥   ᨨ WBDOSyB  gBveryB.  筮 ⠪    ᮧ\n"
"       ᫮        䠩.  室  \n"
"   ᮧ        ,    㦭  ᫥⥫쭮\n"
"   믮 㯯 .\n"
"\n"
"      cB3.  ⭮ ࠡ⪨.yB\n"
"       ⮬  ࠧ   ஡ ᬮਬ  ,  室 \n"
"   ᠭ  䠩.   ᬮ७      易⥫\n"
"   ࠬ     㣮  ᪮  WB<>yB,   易⥫ - \n"
"    WB[]yB.\n"
"       WBREMyB  ᯮ   ਥ  ⥪ ⭮\n"
"   䠩.   ᥣ  ᯮ   ⮣,  ⮡  ६    \n"
"   ⥪ - . ଠ :\n"
"      gBREM [ ப]yB\n"
"          ப WBREMyB  ந  ⢨.\0",
"       WBECHOyB ᯮ  뢮  ࠭ ᮮ饭. ଠ:\n"
"      gBECHO [ON  OFF  饭]yB\n"
"      ࠬ WBONyB  WBOFFyB   몫  뤠    ࠭  ⥬   \n"
"   ᮮ饭  (\"\").    WBECHO  OFFyB  ⪫砥 뤠  ࠭ ப\n"
"   ,  砥    ⭮  䠩    ᯮ,   ⮡   \n"
"   \"\"  ࠭      ᯮ.  ந쭠 ப ᫥ WBECHOyB\n"
"     ᮮ饭      뢮    ࠭.  \n"
"   ப 砥  窮. ਬ:\n"
"      gBecho.yB ३  ᫥饩 ப;\n"
"      gBecho ணࠬ    !yB  뤠  ࠭ ᮮ饭 \"ணࠬ \n"
"   !\".\n"
"\n"
"       뢮 ᮮ饭 ⭮  箪 WB@yB.     ⮫쪮 \n"
"   ᨬ ப    뤠  ࠭.  ᯮ  ⮫쪮  \n"
"   ⭮ ०. ਬ:\n"
"      gB@echo offyB 몫砥 \"\"; - ᨬ WB@yB ᠬ                        \n"
"       WBecho offyB ⮦  뢮    ࠭;  ⮩  ப  筮\n"
"   稭  䠩.\n"
"\n"
"       WBPAUSEyB  ਮ⠭  뢮    ࠭,  뢮 ᮮ饭\n"
"   WB\"Press any key to continue...\"yB     .  ࠬ஢\n"
"    .\0",
"      yB WBIFyB    ஢  ᫮    믮  ⢫  \n"
"   ᨬ  १ ஢ન. 騩  :\n"
"      gBIF [NOT] <᫮> <⢨>yB\n"
"       \"WB⢨yB\"  -  ,  믮塞,  ᫨ ⨭ ᫮.\n"
"   ᫮ 뢠     ,  ⮬  WBIFyB  \n"
"   ଠ.\n"
"      cBଠ 1yB.  ஢ઠ  襭  ᫥  ।  ஬  WBIFyB   \n"
"   . ᯮ  ᫥饣 :\n"
"      gBIF ERRORLEVEL <᫮>yB\n"
"       ணࠬ      ࠡ         ᢮  砭\n"
"   ᮡ⢥  襭,   㯥  㣨  ணࠬ  १\n"
"   ६     WBERRORLEVELyB.  設⢮  WBDOSyB  ଠ쭮   \n"
"   襭 ⠭ errorlevel=WB0yB.  ᫮ WBif errorlevel 1yB,    \n"
"   ।,      㤥 믮,  ᫨ ணࠬ ࠡ뢠 \n"
"   襭 WB訩,  ࠢyB 1.\n"
"      cBଠ 2yB.  ஢ઠ  䠩  ⠫.   ⮬ 砥 \n"
"   WBIFyB  :\n"
"      gBIF EXIST < 䠩>yB\n"
"        砥  WBIFyB  ஢,  ⢨⥫쭮    \n"
"   䠩          㪠   ⥪饬  ⠫.   -\n"
"   㦥 䠩 ᫮ ⠥ 믮.   ᯮ짮 WByB\n"
"   - ⮣ ᫮ 믮, ᫨    WByB 室騩 䠩.\0",
"      cBଠ 3yB. ࠢ  ப.   :\n"
"      gBIF <ப_1>==<ப_2>yB\n"
"      ᫮ 믮, ᫨ ப 1  2 WBᮢyB. ⮡ 客-\n"
"     ,     ப 뢠 ⮩, 筮  ப\n"
"   WB   ᨬyB, ਬ,   ᪮.\n"
"          ᫮     ᪮ -\n"
"   栭 WBNOTyB.   ⮬ ⨭ ᫮ ࠪ  ⭮  ᫥,\n"
"     ⢨ 믮,  ᫨ ⨭ ᫮, WB⨢yB -\n"
"   ,  ᠭ  ᫮ WBNOTyB.\n"
"      ਬ:\n"
"      gBif exist c:\\autoexec.bat type c:\\autoexec.batyB\n"
"      ᫨   ⠫ ᪠ c:  䠩 autoexec.bat, 뢥 \n"
"    ࠭;\n"
"      gBif not exist c:\\WORK\\*.* echo  䠩!yB\n"
"      ᫨  ⠫ WORK    䠩, 뢥 ᮮ⢥饥 -\n"
"   饭;\n"
"      gBformat a:yB\n"
"      gBif errorlevel 1 echo ଠ஢ 諮  筮!yB\n"
"      ᫨ ணࠬ format ⠭ errorlevel   ,ᮮ  \n"
"   訡;\n"
"      gBif '%%A'=='Yes' clsyB\n"
"      ᫨ ६ %%A ᮢ  ப Yes,   ࠭. -\n"
"   筮  WBIFyB  ᯮ짮   ப.\0",
"      yB WBGOTOyB  WB। ࠢyB       ⥬  ᠬ\n"
"   ⢫ ୮ ᯮ ⪮  䠩 ,  -\n"
"   ,  室  ⪨ (    ⠭  \n"
"   ⢫ WBIFyB). ଠ :\n"
"      gBGOTO <⪠>yB\n"
"       WB⪠yB - 稭饥   WB:yB  祭 ⮣   -\n"
"    䠩, 㤠 ᮢ蠥 室. ਬ:\n"
"      gBif '%%A'=='Yes' goto ClearyB\n"
"      gBgoto Not_ClearyB\n"
"      gB:ClearyB\n"
"      gBclsyB\n"
"      gB:Not_ClearyB\n"
"      ᫨ ६ %%A ᮢ  ப Yes,  ३   Clear\n"
"     ࠭. ⨢ 砥 ய  ࠭.\n"
"\n"
"       WBCALLyB    ⢨ WB맮yB   䠩 \n"
"   㣮  ᫥騬 ⮬  뢠騩 䠩. ଠ :\n"
"      gBCALL < 䠩>yB\n"
"        뢠 䠩   ᮤঠ  祭  ᪮,\n"
"      ⥫ ࠬ,   ࠡ뢠 맢 䠩-\n"
"   . ਬ:\0",
"      cB뢠騩  䠩yB: (example.bat)\n"
"      gB@echo offyB\n"
"      gBecho  饭!yB\n"
"      gBcall versionyB\n"
"      gBecho த!yB\n"
"      cB뢠  䠩yB: (version.bat)\n"
"      gB@echo offyB\n"
"      gBecho   DOS:yB\n"
"      gBveryB\n"
"      gBpauseyB\n"
"      example.bat 뢠 version.bat, ᫥ 믮 ண  -\n"
"   砥 ࠢ.\n"
"\n"
"      cB4.६   䠩.yB\n"
"      ६ ᯮ   ଠ樥   ⤥묨  -\n"
"    ⭮ 䠩.    :\n"
"      cB1)yB ६,  ।塞  横.   ⮨  WByB ᨬ\n"
"   WB業yB  ᫥饩   WB㪢yB,  ਬ, %%A.  祭,-\n"
"    ᫥⥫쭮 ਭ ⠪ ६,     ।-\n"
"      WBforyB (. ).\n"
"      cB2)yB ६ 㦥.  ,    ।  ७\n"
"    WBDOSyB \n"
"      gBSET []=[祭]yB,\0",
"      yB WByB  WB祭yB - ந WBபyB,    祭  ᥣ  ᥠ\n"
"   ࠡ ࠭  ᯥ樠쭮  ,  뢠 \"WB⥬ -yB\n"
"   WB㦥yB\".  ⥬ 㦥  ࠢ    ஬\n"
"   WBcommand.comyB.  ⮡  ᯮ짮 ६ 㦥   䠩\n"
"   㦭     ᨬ 業 WB%yB, ਬ, \n"
"      gBset weekday=sundayyB\n"
"      gBecho %weekday%yB\n"
"      ६    weekday ᢠ 祭 sunday  뢮 \n"
"   祭  ࠭  WBECHOyB.   㤠 ६    㦥\n"
"   ᯮ ப \n"
"      gBset =yB\n"
"\n"
"       WBFORyB ᯥ稢 WB横᪮ 믮yB    WBDOSyB.  ଠ\n"
"    ᫥騩:\n"
"      gBFOR ६ IN () DO ⢨yB\n"
"      ⨥ WB६yB  ।  ।饬 㭪.  WByB -  \n"
"    ᪮쪮 WBபyB,  ࠧ WB஡yB  WB묨yB.   ᥣ  \n"
"   ⢥  ⮢  㯠 WB 䠩yB  WB᪨yB.  WB⢨yB -\n"
"    ⨬ .   ࠡ⠥ ᫥騬  ࠧ:  ६\n"
"   ᫥⥫쭮  ਭ 祭 ⮢    ⠢\n"
"    ⥪ . ਬ:\0",
"\n"
"      gBfor %%a in (*.txt) do copy %%a conyB\n"
"      ६ %%a  ᫥⥫쭮 ᢠ  䠩  -\n"
"    txt  ⥪饩 ४ਨ   䠩 뢮  ࠭.\n"
"      gBfor %%r in (*.*) do if exist a:\\%%r echo %%r   ᪥ a:yB\n"
"       ॡࠥ 䠩 ⥪饩 ४ਨ  ,      \n"
"   ᪥ a:  䠩  ⠪  . ᫨ ⠪ 䠩 , ⠥\n"
"   ᮮ饭.  ६ %%r   WBECHOyB  ࠧ ⠢\n"
"   ।  䠩.\n"
"      gBfor %%z in (0,1,2,3,4,5,6,7,8,9) do if %%z==%test% echo z=test=%%zyB\n"
"      ᫨ ६ %%z, ਭ 祭   WB0yB  WB9yB, ᮢ \n"
"   ६ 㦥 test,⠥ ᮮ饭.\n"
"       WBFORyB  ᯮ짮    ப WBDOSyB,  ਬ,\n"
"    ⭮ 믮 ,  ன  ᯮ짮 -\n"
"   . ਬ:\n"
"      gBFOR %A IN (*.doc) TYPE %AyB\n"
"         ⥪饩 ४ਨ 䠩  ७ WBDOCyB ᫥-\n"
"   ⥫쭮 뢮  ࠭. ⢥ ࠧ稥  ਬ WBFORyB  -\n"
"    ப ⮨  ⮬,  ।  ६ 横 ⠢\n"
"   WByB  業.\0",
"\n"
"      cB5.ࠬ  䠩yB.\n"
"       ᪥      ப  WBDOSyB ⭮ 䠩,    \n"
"   ணࠬ,    । WBࠬyB.   ࠧ WB஡yB  \n"
"   ⢮     ॢ WByB.   ⭮ 䠩 -\n"
"    㯭 १ ப  WB%0yB,  WB%1yB,  ...,  WB%9yB,  %0 -  ᠬ\n"
"    䠩,  %1 -  ࢮ ࠬ  ⠪ .  ਬ, \n"
"   ᪠  䠩 MOVA.BAT \n"
"      gBmova.bat *.tmp *.txt *.docyB\n"
"      ᫥ ᪠ ࠬ %0 ࠢ  ப  \"mova.bat\",  ࠬ  %1  -\n"
"   ப \"*.tmp\"  .  .   䠩  ६ 䠩, -\n"
"   室騥  ।  ᪨,    a:.  ࢮ ࠬ \n"
"    ᤥ  :  gBcopy %1 a:\\%1yB  gBdel %1yB.  ࢠ \n"
"   䠩   a:,   㭨⮦ 筨 ஢.    ண\n"
"   ࠬ       , ⠢   %2 \n"
"   %1.  ணࠬ ࠧ  ⠭ 樮쭮, ⥬ ,  -\n"
"    ࠬ஢ ࠭ ⭮.      WBSHIFTyB, -\n"
"    WBᤢyB ࠬ  䠩  WB yB.  ᫥ ਬ\n"
"   WBSHIFTyB ࠬ %0 ᢠ ஥ 祭 %1,   襬 砥 \n"
"   ப \"*.tmp\",   ࠬ %1 ਭ 祭 \"*.txt\".   ⨬\n"
"         ࠡ  ᫮ ࠬ஢.  -\n"
"   ⨢  ᫮ 室  ணࠬ, 砥  ⥫ ⥪:\0",
"\n"
"      gB:LOOPyB\n"
"      gBcopy %1 a:\\%1yB\n"
"      gBdel %1yB\n"
"      gBshiftyB\n"
"      gBif not [%1]==[] goto LOOPyB\n"
"        WBSHIFTyB   ࠧ 頥     ࢮ  \n"
"   । ࠬ஢  ࠢ쭮 ࠡ    ᫠ ।-\n"
"    ࠬ஢.  ᫨ । ப  ᪮  ,   gBgotoyB\n"
"   gBLOOPyB । ࠢ  砫 ணࠬ.\n"
"\n"
"      cB6. ⥫ ।⢠  ᠭ  䠩.yB\n"
"      ᬮ७    ⭮ ࠡ⪨  ࣠\n"
"   ⮬᪨  ணࠬ  ࠡ 䠩.   墠⠥  -\n"
"   ⥩ 짮⥫    ,   ⭮, \n"
"   믮 ⢨  ᨬ  롮  .\n"
"       ⠢ ᫥ ᨩ WBDOSyB 祭   WBchoiceyB, 㦠-\n"
"     롮 ⢨. ଠ :\n"
"      gBCHOICE [/C:] [/N] [/T:롮,६] [ᮮ饭]yB\0",
"\n"
"      yB WBᮮ饭yB -  ப ⥪,  WByB  -  ᯨ᮪  㪢\n"
"   祭  ,  ⨬    롮.   㬮砭 ய \n"
"    㪢 WByB ࠧ,   ᫨ ᯨ᮪   㪠, ਭ-\n"
"    WB/C:YNyB.  ࠬ WB/NyB 頥 뢮 ᫥ ᮮ饭 ᯨ᪠  \n"
"    ,   ᫥ ࠬ WB/TyB   㪠 WB롮yB, ਭ-\n"
"     ⢨     WB६yB  ᥪ㭤,  १ ஥\n"
"    㤥 ᤥ.\n"
"      WByB ࠡ  - ⠭ 祭 WBERRORLEVELyB  ࠢ  -\n"
"   浪 WByB  ᯨ᪥ ࠭ .  ਬ,  ᫥  -\n"
"   \n"
"      gBchoice /c:01 /n /t:0,5 த?(1-,0-)yB\n"
"      祭 ERRORLEVEL 㤥 ⠭  WB1yB  ⨨   WB0yB  \n"
"   ⢨     祭 WB5yB ᥪ㭤,    ⨨ \n"
"   WB1yB ணࠬ ⠭ 祭 ERRORLEVEL, ࠢ WB2yB.\n"
"        㣨 ।⢠ ࣠樨  䠩.  ⭮-\n"
"   ,  ᯥ樠쭮   楫 ।祭  ணࠬ  WBBatch  EnhanceryB\n"
"   (䠩 WBbe.exeyB)   WBNorton UtilitiesyB.    ⮫쪮 -\n"
"   뢠  롮,    ᮢ  ࠭   ࠬ,  -\n"
"     ࠧ묨 梥⠬  ..\n"
"\n"
"   GB[ ⥪]\0"
};
 char *questions[QUESTIONS]={
  "c0  䠩 ᮤঠ:",
  "c0DOS ।  䠩 ",
  "c0 ப \nREM DIR",
  "c0 뢮 ᮮ饭 ᯮ",
  "c0 뢮 ⮩ ப ᫥ \n ",
  "c0ERRORLEVEL ",
  "c0    ୮?",
  "c0    ୮?",
  "c0     ஢\n 稥 䠩  ᪥?",
  "c0   ᮧ  \n ६   祭?",
  "c0 ⠪ \"⥬ 㦥\"?",
  "c0  । ࠬ \n  䠩?",
  "c0 砥  %1 ?",
  "c0  ᤥ  SHIFT ?"
 };
 char maxlen=38;
 char points[QUESTIONS]=
  {3,3,3,3,3,3,3,3,3,3,3,3,3,3};
 char correct[QUESTIONS]= //  ࠢ ਠ⮢
  {3,2,2,2,3,3,3,2,2,3,1,2,1,1};
 char goscreens[QUESTIONS]= // ࠭, 㤠 ᫥   砥 ࠢ. ⢥
  {1,1,2,3,3,4,9,11,4,7,8,10,10,10};
 char *replies[QUESTIONS][MAXANSWERS]={ // ਠ ⢥⮢
  {"設 ","⮫쪮  DOS"," DOS  맮 㣨 ணࠬ"},
  {"७ COM, EXE  BAT","७ BAT",""},
  {"믮  DIR","㤥 ந஢","㤥 ਧ 訡筮"},
  {" @"," ECHO"," REM"},
  {"ECHO","@ECHO OFF","ECHO."},
  {"ᮮ饭  訡","ணࠬ ஫ 訡"," 襭 ᫥ ணࠬ"},
  {"for %%a do type %%a","FOR %a in *.txt do type *.txt","for %%a in (*.bak) do copy %%a con"},
  {"choice c:012 /n","choice /c:012 롥 ⢨:","choice 012?"},
  {"IF ERRORLEVEL","IF EXIST","FOR"},
  {"FOR","ECHO","SET"},
  {"樠쭠    ","਩  "," ணࠬ 樮 ⥬"},
  {"  ࠭祭",",   ᫮ ࠭祭",""},
  {" ࠬ  䠩","६ 㦥   \"1\""," 뢠  䠩"},
  {"ࠡ  9 ࠬ஢ 䠩","맢 㣮  䠩","ᬮ ⥬ 㦥"}
 };
 char see[SCREENS];    // 뫨  ᬮ७ ࠭
 char *mm1[2]={"  ࠧ","  DOS"},
      *mm0[2]={"  ணࠬ","  DOS"};
 char *Bad= "WR    ᮦ,  ⢥ yB७WR!\n" // 5 str, 34 col
            "  yBWR  \n"
            " 祭.   yBESCWR   \n"
            "祭,    ᬮ yBWR \n"
            " .";
 char scr,k,out,que,inque=NO,c,*numpage="__";
 unsigned all,bad;

 if (!textmode()) {
  beeps ("asdfghj\0"); return;
 }
 goto_xy(0x19,0x00);
 Init_int1C();
AGAIN:
 kbclear();
 for (k=0; k<SCREENS; k++) see[k]=NO;
 for (scr=0;;) {
AGAIN_2:
  //!!! movescreen (1+scr%4);
  EXPLODE=YES; SHADOW=NO;
  ATTR=set_attr (YELLOW,BLUE);
  window (0,0,24,79);
  text (1,1,23,78,screen[scr]);
  if (scr) {
   ATTR=set_attr (WHITE,BLUE);
   utoa (scr,numpage,2);
   center_string (24,1,78,numpage);
  }
READKEY:
  c=kbscan();
  see[scr]=YES;
  for (k=0,out=YES; k<SCREENS; k++) if (see[k]==NO) { 
   out=NO; break; 
  }
  switch (c) {
   case _DOWN: if (scr<SCREENS-1) scr++; else goto READKEY; break;
   case _UP:   if (scr>0) scr--; else goto READKEY; break;
   case _ESC:
    if (out) {
     if (inque) { inque=NO; goto IN_QUE; } 
     else goto FIRST;
    }
    else {
     k=popup (6, 28, 9, 52, YELLOW,GREEN, 2, mm0);
     if (k) goto OUT_MAIN;
    }
   break;
   default: goto READKEY;
  }
  continue; // 頥  ப⪥ ࠭
FIRST:
  que=0; bad=0; all=0; 
  clear (0,0,24,79); ATTR=set_attr(LIGHTGRAY,BLACK); 
  EXPLODE=YES; SHADOW=NO; window (0,0,24,79);
  text (8,22,14,57,
         "c0 ⠫  ⥪.  \n" // 8str, 35 col
         "।  ⢥   .\n"
         "롨ࠩ  ਠ ⢥ 蠬\n"
         " ५ W0c0/W0c0  \n"
         "W0ENTERc0. ६   ⢥ - W015c0.\n"
         "g0     室\n"
         "            ᠬ...\0");
  kbscan(); clear (0,0,24,79);
  for (; que<QUESTIONS; que++) {
IN_QUE:
   save (20,30,23,51);
   timewindow (20, 30, 51, "६  ⢥!");
   save (2,18,5,62); 
   ATTR=set_attr (YELLOW,BLACK); SHADOW=NO; window (2,18,5,62);
   text (3,20,4,61,questions[que]);
   k=popup (8, ((80-maxlen)>>1), 9+points[que],((80+maxlen)>>1), 
     YELLOW, GREEN, points[que],replies[que]);
   TIMEDRAW=NO; delay (20);
   restore (2,18,5,62); //  
   restore (20,30,23,51); // 饭  ६
   all++;
   if (k==0xff || (k!=correct[que]-1)) {
    kbclear();
    ATTR=set_attr (WHITE,RED);
    window (9,22,15,58);
    text (10,23,14,57,Bad);
    kbscan();
    scr=goscreens[que];
    inque=YES;
    bad++;
    goto AGAIN_2;
   }
  }
  estimation (bad,all);
  inque=NO;
  k=popup (6, 30, 9, 50, YELLOW,GREEN, 2, mm1);
  if (k) goto OUT_MAIN; 
  else goto AGAIN;
 }
OUT_MAIN: 
 Shut_int1C();
 ATTR=0x07; clear (0,0,24,79);
 goto_xy(0x15,0x00);
 return;
}
