#define YES 0x01
#define NO  0x00
#define     BLACK   0x00
#define     BLUE    0x01
#define     GREEN   0x02
#define     CYAN    0x03
#define     RED     0x04
#define     MAGENTA 0x05
#define     BROWN   0x06
#define     LIGHTGRAY 0x07
#define     DARKGRAY  0x08
#define     LIGHTBLUE 0x09
#define     LIGHTGREEN 0x0A
#define     LIGHTCYAN 0x0B
#define     LIGHTRED 0x0C
#define     LIGHTMAGENTA 0x0D
#define     YELLOW 0x0E
#define     WHITE 0x0F
#define     BLINK 0x80

char FILLER=' ',
     ATTR=0x07,
     SHADOW=YES,
     EXPLODE=YES;

unsigned char far *vid_mem=(unsigned char far *)0xb8000000,
              far *V;

char set_attr (char col, char bk) {
 char ATTR=0x00;
 ATTR|=col;
 ATTR|=(bk<<4);
 return (ATTR);
}

void write_char (char x, char y, char ch) {
 V=vid_mem;
 V += ((x*80 + y)<<1);
 *V++ = ch; /*  ᨬ */
 *V = ATTR; /*  ਡ */
}

void write_string (char x, char y, char *str) {
 char i;
 for (i=0;  *(str+i); i++) write_char (x, y+i, *(str+i));
}

char strlen (char *str) {
 char i;
 for (i=0x00; *(str+i);) i++;
 return (i);
}

void center_string  (char x, char y1, char y2, char *str) {
 char i,y;
 y=(y1+y2-strlen(str))>>1;
 for (i=0;  *(str+i); i++) write_char ( x, y+i, *(str+i));
 return;
}  

char read_char (char x, char y, char *attr) {
 char ch;
 V=vid_mem;
 V += ((x*80 + y)<<1);
 ch = *V++;  /* ᨬ */
 *attr = *V; /* ਡ */
 return (ch);
}

void change_attr (char x1, char y1, char x2, char y2, char attr) {
 char i,j;
 V=vid_mem; x2++; y2++;
 for (i=x1; i<x2; i++)
 for (j=y1; j<y2; j++) {
  V = vid_mem + ((i*80 + j)<<1) + 1;
  *V = attr; //  ਡ
 }
}

void save (char x1,char y1,char x2,char y2) {
 char i,j,ch,attr;
 x2++; y2++;
 for (i=x1; i<x2; i++) 
 for (j=y1; j<y2; j++) {
  ch=read_char (i,j,&attr);
  ATTR=attr;
  vid_mem+=4000;
  write_char (i,j,ch);
  vid_mem-=4000;
 } return;
}

void restore (char x1,char y1,char x2,char y2) {
 char i,j,ch,attr;
 x2++; y2++;
 for (i=x1; i<x2; i++) 
 for (j=y1; j<y2; j++) {
  vid_mem+=4000;
  ch=read_char (i,j,&attr);
  vid_mem-=4000;
  ATTR=attr;
  write_char (i,j,ch);
 } return;
}

char kbscan(void) {
 char sim;
 asm MOV  AH,0x00;     //뢠 ᨬ   
 asm INT  16H;
 asm MOV sim,AH; // AH=Scan-code, AL=ASCII code
 return (sim);
}

void kbclear(void) {
asm push es;
asm  cli;
asm  sub ax,ax;
asm  mov es,ax;
asm  mov al,es:[41ah];
asm  mov es:[41ch],al;
asm  sti;
asm pop es;
}

void clear (char x1,char y1,char x2,char y2) {
 char i,j;
 x2++; y2++;
 for (i=x1; i<x2; i++) 
 for (j=y1; j<y2; j++) write_char (i,j,FILLER);
 return;
}

void box (char x1, char y1, char x2, char y2, char sort) {
// ᮢ ࠬ:
//  012 Ŀ ͻ ķ ͸ ķ   
//  3 4 1 2 3 4 5 6 7
//  567  ͼ ͼ ; Ľ  
 unsigned char border[8][8]={
  {' ',' ',' ',' ',' ',' ',' ',' '},
  {'','','','','','','',''},
  {'','','','','','','',''},
  {'','','','','','','',''},
  {'','','','','','','',''},
  {'','','','','','','',''},
  {'','','','','','','',''},
  {'','','','','','','',''}
 };
 char i;
 if (!sort) for (i=0; i<8; i++) border[0][i]=FILLER; //  -ࠧ⥫
 for(i=x1+1; i<x2; i++) { // 
  write_char (i,y1,border[sort][3]);
  write_char (i,y2,border[sort][4]);
 }
 for (i=y1+1; i<y2; i++) { // ࠢ
  write_char (x1,i,border[sort][1]);
  write_char (x2,i,border[sort][6]);
 }
 write_char( x1, y1, border[sort][0]);
 write_char( x1, y2, border[sort][2]);
 write_char( x2, y1, border[sort][5]);
 write_char( x2, y2, border[sort][7]);
 return;
}

void window (char x1,char y1,char x2,char y2) {
 char j,cx1,cy1,cx2,cy2;
 if (EXPLODE) {
  cy1=(y2-y1)>>1;
  cy2=cy1+1;
  cx1=(x2-x1)>>1;
  cx2=cx1+1; 
  j=0x0f;
  do {
   box (cx1,cy1,cx2,cy2,0x02);
   FILLER=' ';
   box (cx1,cy1,cx2,cy2,0x00);
   if (cx1>x1) cx1--;
   else j&=0x0e;
   if (cx2<x2) cx2++;
   else j&=0x0d;
   if (cy1>y1) cy1--;
   else j&=0x0b;
   if (cy2<y2) cy2++;
   else j&=0x07;
  } while (j);
 }
 else { // normal
  FILLER=' ';
  clear (x1,y1,x2,y2); 
 }
 box (x1,y1,x2,y2,0x02);
 if (SHADOW) {
  j=y2+2;
  if (j<80) change_attr (x1+1, y2+1, x2, y2+2, 0x08); //Ver
  j=x2+1;
  if (j<25) change_attr (x2+1,y1+2,x2+1,y2+2, 0x08); //Hor
 } return;
}

#define UPR_SIM 0xfe

void text (char x1, char y1, char x2, char y2, char *str) {
 char Cods[16]= {
  '0','B','G','C','R','M','Y','L', 
  'D','b','g','c','r','m','y','W'
 };
 char i,j,k,sim,is1,is2,cod1,cod2;
 int n=0;
 x2++; y2++;
 for (i=x1; i<x2; i++) {
  if (str[n]=='\0') break;
  for (j=y1; j<=y2; j++) {
AGAIN:
   sim=str[n++];
   if (sim==UPR_SIM) {
    cod1=str[n++];
    for (k=0,is1=17; k<16; k++) if (cod1==Cods[k]) { is1=k; break; }
    if (is1<17) {
     cod2=str[n++];
     for (k=0,is2=17; k<8; k++) if (cod2==Cods[k]) { is2=k; break; }
     if (is2==17) sim=cod2;
     else { ATTR=set_attr(is1,is2); goto AGAIN; }
    }
    else sim=cod1;
   }
   if (sim=='\r') goto AGAIN;
   if (sim=='\n') break;
   if (sim=='\0') return;
   write_char (i,j,sim);
  }
  j=0;
 }
}

#define _ESC 0x01
#define _SBAR 0x39
#define _ENTER 0x1C
#define _PAGE_UP 0x49
#define _UP 0x48
#define _DOWN 0x50
#define _PAGE_DO 0x51

char popup (char x1, char y1, char x2, char y2, char col, char bk,
 char kol, char **str) {
 char cursor=0x00,sim,rev,i;
 save (x1,y1,x2,y2);
 ATTR=set_attr (col,bk);
 rev=0x70;
 FILLER=' ';
 clear (x1,y1,x2,y2);
 box (x1,y1,x2,y2,0x02);
 for (i=0; i<kol; i++) write_string (x1+1+i, y1+1, str[i]);
 while (1) {
  change_attr (x1+1+cursor, y1+1, x1+1+cursor, y2-1, rev);
  sim=kbscan();
  change_attr (x1+1+cursor, y1+1, x1+1+cursor, y2-1, ATTR);
  switch (sim) {
   case _ENTER: goto OUT;
   case _UP: 
    if (cursor>0x00) cursor--;
    else cursor=kol-0x01;
   break;
   case _DOWN: 
    if (cursor<kol-0x01) cursor++;
    else cursor=0x00;
   break;
   case _PAGE_UP: cursor=0x00; break;
   case _PAGE_DO: cursor=kol-0x01; break;
   default: break;
  }
 }
OUT: 
 restore (x1,y1,x2,y2);
 return (cursor);
}

void strrev(char *s) {
 char c; char *t;
 for (t=s+strlen(s)-1; s<t; s++,t--) {
  c=*s; *s=*t; *t=c;
 }
}   

void utoa (unsigned n, char *str,char field) {
 char *t=str,byte;
 for (byte=0x00; byte<field; byte++) *(str+byte)=' ';
 do {
  *str++=n%10+'0';
 } while ((n/=10)!=0);
 byte=*str; *str='\0';
 strrev (t);
 *str=byte;
 return;
}

char textmode (void) {
 // ⠭ ० 3, 80*25, 16 梥⮢
 // 頥 0  砥 訡
 asm mov ax,0003h;
 asm int 10h;
 asm mov ah,00fh;
 asm int 10h;
 asm cmp al,003h;
 asm jnz ModeError;
 asm mov al,1;
 asm jmp Exit;
ModeError:
 asm mov al,0;
Exit:
 return (_AL);
}

void goto_xy(char xpos,char ypos) {
 asm  mov	ah,0x02 ;
 asm mov	dl,ypos ; //⮫
 asm mov	dh,xpos	; //ப
 asm mov	bh,0x00 ;
 asm int	10h;
}

//////////////// ᭮  ணࠬ
#define SCREENS 13

void main (void) {
 char *screen[SCREENS]={
 "yB\n"
"ķ\n"
"  gB                         yB  \n"
"  gB                         yB  \n"
"  gB                           yB  \n"
"                                                       cBķyB  \n"
"  gB        yB                       cB ᨡ yB  \n"
"  gB            yB                       cB   1 9 9 5   yB  \n"
"  gB          yB                       cBͼyB  \n"
"ķ \n"
"                               gBķyB    DOS  ᬮ       ۺ\n"
"    ᬠਢ            gBWBESCgByB  ⥪                         ۺ\n"
"    ᫥騥 :         gBͼyB                                 ۺ\n"
"                               gBķyB  ३  ᫥饩 ࠭   ۺ\n"
"    WB 樮yB     gB WBgB yB   㭪                 ۺ\n"
"    WB⥬ MS-DOSyB;            gBͼyB                                 ۺ\n"
"    WB னyB            gBķyB  ३  ।饩 ࠭  ۺ\n"
"    WB樮 ⥬yB.      gB WBgB yB   㭪                 ۺ\n"
"                               gBͼyB                                 ۺ\n"
"ͼۺ\n"
" ߺ\n"
"ͼ\n"
"\0",
"   yB\n"
"      cB1. 祭   .\n"
"\n"
"      WB樮 ⥬yB - ᮢ㯭 ணࠬ,  ࣠   \n"
"   짮⥫, ⢫ ࠢ ᠬ   ᪠-\n"
"     믮 㣨 ணࠬ. ⢨  짮⥫ -\n"
"   ⢫ १ WB yB,    ண 짮⥫ \n"
"   ࠢ ࠡ⮩   ᮥ   ன.  -\n"
"    樮 ⥬  뤥 ᫥騥 :\n"
"\n"
"      -  室 몠,   WB yB;\n"
"      - WB䠩 ⥬yB;\n"
"      - WBࠩyB 譨 ன.\n"
"\n"
"      WB yB -  ணࠬ,  ।⢥ -\n"
"    뫠  ᯮ   ᯥ稢  믮.\n"
"\n"
"      WB ⥬yB  ।祭  ࠢ ணࠬ  묨,\n"
"   ࠭騬  ⪮ ᪥    䠩.\n"
"\n"
"      WBࠩyB ।⠢ ᮡ ணࠬ ࠢ 譨 ன⢠-\n"
"   , 砥묨  , ⠪   \"\", ਭ.\0",
"yB\n"
"      cB2.  樮 ⥬ MS-DOS.yB\n"
"\n"
"       WBDOSyB  뤥 ᫥騥 WB஢yB ࣠樨:  ᠬ  -\n"
"    ணࠬ, ।⢥ ࠢ騥 ⭮  -\n"
"   ,  ᠬ ᮪ ஢ - ।⢠  ࣠樨 WByB  짮-\n"
"   ⥫,  ஬ ஢  ।⢠, ࣠騥 WB믮-\n"
"   yB  ⢨ ணࠬ, ⥭   , । -\n"
"     . .  ⨬ ஢ﬨ ந室  ଠ樥 - 孨\n"
"   㫨   ,   ,  ᢮ ।,  ᢥ-\n"
"     믮.\n"
"\n"
"       奬  ᭮ 㫨 WBDOSyB,   ᪮ ਢ  -\n"
"   :\n"
"\n"
"      -  ⥬ -뢮 (WBBIOSyB - Basic Input-Output System);\n"
"\n"
"      -  ७  ⥬ -뢮 (䠩 gBIO.SYSyB);\n"
"      -  ࠡ⪨ ⥬ 뢠 (䠩 gBMSDOS.SYSyB);\n"
"\n"
"      -   (䠩 gBCOMMAND.COMyB);\n"
"      - 譨 ;\n"
"      - ࠩ ன.\0",
"yB\n"
"      gB ࠧ饭yB:            gB㫨 MS-DOSyB:\n"
"                        Ŀ\n"
"      WB⥬yB         COMMAND.COM 譨   ࠩ  \n"
"      WB yB                      ன \n"
"      WByB              \n"
"                         Ŀ\n"
"      WB⥬yB                                    \n"
"      WByB               砫쭮  IO.SYS   MSDOS.SYS \n"
"                         㧪                      \n"
"                         \n"
"                                 Ŀ\n"
"      WBﭭ  -yB            BIOS      \n"
"      WB饥 ன⢮ ()yB      \n"
"\n"
"      WBBIOSyB ࠧ頥     WByB        ६  \n"
"   ⭮  ,  ⠪     樮  ⥬.  \n"
"   ᭮ 㭪樨   ᫥饬:\n"
"      - WB஢yB   祭  뤠 ᮮ饭  -\n"
"   砥 ⭮ ࠢ;\n"
"      - WByB  㧪   ⨢    WB  砫쭮  㧪yB\n"
"   ⥬ ᪠  -  让  ணࠬ,    㦠   \n"
"   ⠫ 㫨 DOS.\0",
"yB\n"
"      - WB㦨yB  WB뢠yB,  ஥ 砥  ਮ⠭-\n"
"    ஬ ⥪饩 ணࠬ  믮 - ⢨  \n"
"   -뢮,  ॡ 饭   (ਬ, ⨥ \n"
"    뢠 WB뢠  yB).\n"
"      WB ७yB 樮 ⥬ gBIO.SYSyB ।祭  믮-\n"
"    権  -뢮, WB 易yB ।⢥  -\n"
"   ன.  ᪨,   ।⠢ ᮡ  ணࠬ  㦨\n"
"   ⠭ ன   ࠡ⠥   (䥩)  \n"
"   ⭮  WBBIOSyB  㫥 gBMSDOS.SYSyB.\n"
"       ࠡ⪨ 뢠 gBMSDOS.SYSyB ᮤন ணࠬ  ࠡ \n"
"   WB䠩 ⥬yB,   ࠢ WByB,  WB믮 ணࠬyB  . .\n"
"   ணࠬ  㯭 १  WB㭪樨yB  -  ਬ,  㭪樨\n"
"    䠩    ⥭,  ᪠  襭 ணࠬ,\n"
"   -    믮    孥 ஢ (WBCOMMAND.COMyB  ணࠬ\n"
"   짮⥫). 設⢮ 㭪権,  ᢮ ।,  믮 -\n"
"       gBIO.SYSyB,   ᫥ -  WBBIOSyB.  㫨 ७  ࠡ⪨\n"
"   뢠   ᪥ WBண । yB,  ⭮, \n"
"   ⮣, ⮡ ⥬ 稪     .\n"
"      WB yB  DOS - ,  ࠢ, ணࠬ   WBCOM-\n"
"   MAND.COMyB,  ࠭  ⥬ ᪥.  WBCOMMAND.COMyB   \n"
"   ᪥    ᬠਢ DOS  筠  ணࠬ.  㭪樨\n"
"       ᫥饬:\0",
"yB\n"
"      - WBਥyB   ࠧ WB 짮⥫  yB   䠩;\n"
"\n"
"      - ।⢥  WBᯮyB 鸞  DOS (⠪  뢠-\n"
"    WB७yB);\n"
"\n"
"      - 㧪       WByB  믮 WBணࠬ 짮⥫yB \n"
"     DOS (  DOS,  COMMAND.COM   믮 ᠬ,\n"
"   뢠 WB譨yB).\n"
"\n"
"\n"
"      WB譨 yB 樮 ⥬ 믮 ࠧ ⢨  \n"
"   㦨 ⥫쭮  ,  ᯥ祭    ன  \n"
"   㤮 ࠡ  ஬  ..   室  ᪥   WB-yB\n"
"   WB  ᯮ ணࠬyB  䠩  ७ﬨ gBCOMyB  gBEXEyB.\n"
"\n"
"\n"
"      WBࠩyB ன -  ணࠬ, 室  ࠢ -\n"
"   ⥫묨  譨  ன⢠.   ࠩ 㦠  ⨢\n"
"    WB ᪥yB 樮 ⥬   ⠬   祭  WBᥣyB\n"
"   WBᥠyB  ࠡ.  ⮬ ࠩ WB yB  饭  筠 ண-\n"
"   ࠬ.\0",
"\n"
"      cB3. 䨣஢ DOS.yB\n"
"\n"
"       WB䨣஢yB   WBᮣᮢyB 樮 ⥬ \n"
"   祭묨   ன⢠   WBᯮᮡyB   -\n"
"    ॡ   짮⥫.  १ த㬠\n"
"   䨣஢   ᮧ WB㤮 ࠡ ⠭yB. DOS \n"
"      ᪥  ⮬᪨  WB砫 -yB\n"
"   WByB,     쭥 ࠡ  .  ⢫\n"
"      ᮤন WB ᯥ樠 䠩yB,  ࠡ뢠-\n"
"    WB  砫쭮 ᪥yB.  䠩 뢠 gBCONFIG.SYSyB  gBAUTO-yB\n"
"   gBEXEC.BATyB.   䠩, ᫨    WB ⠫yB ⥬-\n"
"    ᪠, ࠡ뢠   祭  १᪥ -\n"
"   . ⮡  ᮡ ன 樮 ⥬,  \n"
"   ஡ ᬮ ,  ந室  ࠧ  祭 -\n"
"   .\n"
"\n"
"      ᫥ 祭   ᠬ஢   WB᪥yB  -\n"
"    ⥬ WB ᪮ a:yB.  ᫨  ⠢    ᪥  DOS\n"
"   ,  뤠  WBᮮ饭  訡yB \"gBNon-system disk or disk er-\n"
"   roryB\" (⥬   訡 ࠡ  ᪮).  ᫨   ᪮\n"
"   a:  ᪥,  誠 ᪮  ,  ⠥ -\n"
"   㧨 樮 ⥬  WB⪮ ᪠ c:yB.    DOS,  \0",
"yB\n"
"      㦠   㫨 WB७ BIOSyB (䠩 gBIO.SYSyB)    WBࠡ⪨\n"
"   뢠yB  (gBMSDOS.SYSyB),  ᫥  祣    WB ⠫yB ᪠ c:\n"
"   WB䠩 䨣樨 ⥬yB gBCONFIG.SYSyB.   䠩  ࠢ  WBனyB\n"
"   DOS    㠫  ॡ   짮⥫.᫥ \n"
"   ⨬ 㦠 WB yB gBCOMMAND.COMyB , ᫨  諮 -\n"
"   쭮,    ⮬   ⠫ WB䠩 ⮧᪠yB gBAUTO-\n"
"   EXEC.BATyB ( . gBauto-executeyB, 믮 ⮬᪨).  䠩 AUTO-\n"
"   EXEC.BAT ᮤন ᯨ᮪  DOS  ணࠬ, । 믮塞\n"
"   WB ࠧ  ᪥ yB.\n"
"\n"
"      cB4.ᠭ 䠩 CONFIG.SYS.yB\n"
"\n"
"         䠩  䨣樨  WByB 樮 ⥬ \n"
"   WByB  稭,  騥  ࠡ 譨 ன. \n"
"      ᢮ DOS ⮨     譨\n"
"   ன  祭 ணࠬ,  ᯥ稢 ࠢ   ࠡ⮩\n"
"   (,   ணࠬ 뢠 WBࠩࠬyB).\n"
"\n"
"    䠩 gBCONFIG.SYSyB  䨪஢ ᮮ⢥騥  ࠩ,  -\n"
"   ⢮  ஢    묨  譨 ⥫ﬨ  -\n"
"    稭.\0",
"yB\n"
"       樨   gBCONFIG.SYSyB 뢠  ப \n"
"      gB=祭yB\n"
"\n"
"          -  gBFILESyB    gBBUFFERSyB.     \n"
"   gBFILES=XXyB  WBᨬ쭮 ⢮ 䠩yB, ஥  -\n"
"       ࠡ  ਪ ணࠬ,    gBBUFFERS=XXyB\n"
"    WB⢮   yB,  ᯮ㥬  ६ -\n"
"    ,     ⠭  ⪮ ᪠  ᠭ\n"
"    .  XX - ᫠  1  99.  㥬 祭  稭  -\n"
"   ᮮ⢥⢥, gB40yB  gB20yB.\n"
"       gBDEVICEyB 㦨  WB祭 ࠩ஢yB.     gBDEVICE=yB\n"
"   室  㪠  WB 䠩yB,   ஬ ᮤন ॡ㥬 ࠩ.\n"
"    ᪥ DOS   㧨   .   ࠩ஢  筮\n"
"     ७ gBSYSyB  gBBINyB    ⠭ ⮫쪮 १ 䠩\n"
"   gBCONFIG.SYSyB ..    ᪠ .  ਬ,  প\n"
"   \"\"  㦠 ᮮ⢥騩 ࠩ \n"
"      gBdevice=c:\\DOS\\mouse.sysyB\n"
"   ᫨ 䠩 ࠩ 室  ४ਨ DOS.\n"
"       gBBREAK=ONyB ⠭ ०,   ஬ 짮⥫ 㤥\n"
"      WBࢠyB  ࠡ ணࠬ ⨥ -\n"
"   樨  gBCtrl-BreakyB.  ⨢ ० ࠡ ⠭ -\n"
"    gBBREAK=OFFyB.\0",
"yB\n"
"       gBCOUNTRY=XXXyB    WB樮 ଠ⮢yB  (,\n"
"   ६, ).  gBXXXyB - 姭 WB ࠭yB.  ᨨ 筮 -\n"
"     007 (ଠ), ᪮ ᨩ᪨ ⠭   -\n"
"   ন  MS-DOS.\n"
"       WBSHELLyB  㪠뢠   䠩,    㤥  \n"
"   ஫  ⠭⭮      ( ⠭⭮ 䠩\n"
"   COMMAND.COM).  㪠 ⢫   ࠦ :\n"
"      gBSHELL=< 䠩    ஬>yB\n"
"\n"
"       ࠧ,    䠩 䨣஢  짮⥫  \n"
"    ᮡ⢥, ⠭ ,    -\n"
"    ⥪饣 ᥠ ࠡ.\n"
"\n"
"      ᬮਬ  ਬ ⥩訩 ਠ gBconfig.sysyB:\n"
"   gBfiles=20yB\n"
"   gBbuffers=20yB\n"
"   gBdevice=c:\\mouse.sysyB\n"
"   gBbreak=onyB\n"
"       gBdeviceyB ⠭ ࠩ \"\", ।,  -\n"
"   ६    gB20yB 䠩,    ࠡ  ᪮ 㤥  -\n"
"   짮  gB20yB  ஢.    gBbreak=onyB  ࠧ蠥  뢠 \n"
"   gBCtrl-BreakyB.\0",
"yB\n"
"      cB5.ᠭ 䠩 AUTOEXEC.BAT.yB\n"
"\n"
"       gBAUTOEXEC.BATyB   WB 䠩yB.  ᮤন WB-\n"
"    ணࠬyB, ᪠  ࠧ  砫쭮 㧪 . \n"
"    筮 ⭮ ணࠬ,  ﭭ  㦠  ,  ⠪\n"
"    WB䨪yB    窠  짮⥫  gBNorton  CommanderyB.\n"
"       ணࠬ ஢ ࠭  䠩,  ࠩ \"-\n"
"   \", - ணࠬ WBDOSyB  .. ਬ,  䠩 gBAUTOEXEC.BATyB \n"
"     ᫥騩 :\n"
"   gBclsyB\n"
"   gBc:\\UTILS\\keyrusyB\n"
"   gBc:\\NC\\ncyB\n"
"        ⥬  頥  ࠭,  㦠  ணࠬ  gBkeyrusyB\n"
"   (࠭   䨪  ),   室    ⠫\n"
"   WBc:\\UTILSyB,  ⥬ ࠢ । 窥 gBNorton CommanderyB, -\n"
"     ⠫ WBc:\\NCyB.\n"
"      ஬   ணࠬ     DOS  䠩 gBAUTOEXEC.BATyB  ᮤ-\n"
"    WB⥬ னyB DOS,  믮塞    gBSETyB (WB-\n"
"   ⠭yB).   ࠢ WB⥬ 㦥yB - ஬ ᨬ-\n"
"    ப, ࠭  ࠢ塞  ஬. ⥬ -\n"
"    ⮨  ப \n"
"      gB=\0",
"yB\n"
"        gBSETyB ,ᮮ⢥⢥,  ଠ\n"
"      gBSET ६=祭yB\n"
"       gBSETyB,    ப, 뢠 ᯨ᮪ -\n"
"    ६ 㦥,    \n"
"      gBSET ६=yB\n"
"   㭨⮦ ᮮ⢥ ६.\n"
"\n"
"        ६ 㦥,   १ࢨ஢  WB-\n"
"    ⥬yB,  ,   㦥   ᢮ ६ \n"
"   ᯮ짮  ਪ묨 ணࠬ.\n"
"\n"
"       䠩 gBAUTOEXEC.BATyB 筮 ᯮ  ᪮쪮  DOS\n"
"   ६ 㦥:\n"
"      ६ gBCOMSPECyB  ।    ⮯ 䠩 \n"
"   .\n"
"      ६ gBPROMPTyB  WB ਣ襭yB DOS   ப.-\n"
"     ਣ襭 ⮨    ⥪饬 ⠫  ᨬ >. ᫨\n"
"   ६ gBpromptyB   ।,  ⠭  ⠭  ,\n"
"   騩     ⥪饣 ᪠  >.   gBPROMPTyB  ࠡ  \n"
"   , ,    ப\n"
"      gBprompt /?yB\n"
"     ਠ⠬ ਣ襭 DOS;\0",
"yB      ६ gBPATHyB । WBᯨ᮪ ⠫yB,  DOS ᬠਢ-\n"
"     ᪠ 饭 ணࠬ,  ᫨     WB⥪饬yB -\n"
"   .     gBPATHyB   ⠫,   ⢨⥫쭮\n"
"   室 WB ᪠yB ணࠬ. ⠫  ᯨ᪥ PATH ࠧ-\n"
"    ᨬ WB窨  ⮩yB.  樮 ⥬ ᬠਢ ⠫-\n"
"   , 㪠  PATH, WB 浪  ᫥yB.\n"
"       ணࠬ ᯮ ⠪ ६ gBTEMPyB  gBTMPyB  ।-\n"
"    ⠫,  ஬ ᫥ ᮧ ६ ࠡ稥 䠩.\n"
"\n"
"        gBAUTOEXEC.BATyB ப\n"
"   gBset comspec=c:\\DOS\\command.comyB\n"
"   gBset prompt=$p$gyB\n"
"   gBset path=c:;c:\\DOS;c:\\NC;c:\\UTILSyB\n"
"   gBset temp=c:\\tmpyB\n"
"      ਢ묨 ப  ⠭,     ᫥\n"
"   ᪠    䠩  WBCOMMAND.COMyB    ⠫  WBc:\\DOSyB,   ਣ襭 DOS\n"
"      ⥪饣 ᪠  ⠫ ($p      gBpromptyB)  \n"
"   ᨬ '>' ($g),   ஬ ⥪饣 ⠫ ᯮ塞 䠩 ᫥\n"
"   ᪠  WByB ⠫   ⠫ WBDOSyB, WBNCyB  WBUTILSyB,   ᮧ\n"
"   ६  䠩  ᯮ짮  ⠫   WBTMPyB.  ᠢ  ⨬ ப\n"
"   ᬮ७   ᪠ ணࠬ,  稬 ਬ 䠩 gBau-\n"
"   toexec.batyB.\n"
"   GB[ ⥪]\0"
 };
 char *mm0[2]={"  ணࠬ","  DOS"};
 char scr,k,c,*numpage="__";

 if (!textmode()) 
  return;
 
 goto_xy(0x19,0x00);
AGAIN:
 kbclear();
 for (scr=0;;) {
AGAIN_2:
  EXPLODE=YES; SHADOW=NO;
  ATTR=set_attr (YELLOW,BLUE);
  window (0,0,24,79);
  text (1,1,23,78,screen[scr]);
  if (scr) {
   ATTR=set_attr (WHITE,BLUE);
   utoa (scr,numpage,2);
   center_string (24,1,78,numpage);
  }
READKEY:
  c=kbscan();
  switch (c) {
   case _DOWN: if (scr<SCREENS-1) scr++; else goto READKEY; break;
   case _UP:   if (scr>0) scr--; else goto READKEY; break;
   case _ESC:
    k=popup (6, 28, 9, 52, YELLOW,GREEN, 2, mm0);
    if (k) goto OUT_MAIN;
   break;
   default: goto READKEY;
  }
  continue; // 頥  ப⪥ ࠭
 }
OUT_MAIN: 
 ATTR=0x07; clear (0,0,24,79);
 goto_xy(0x00,0x00);
 return;
}
asm db 10,13,'Nick Soft',10,13,'$'